<template>
  <label
    class="ui-checkbox flex items-start text-base leading-snug outline-none lg:text-lg lg:leading-snug xl:text-xl xl:leading-snug"
    :class="[
      {
        'bg-white': (!button && !checked) || (!button && !disabled),
        'focus-within:text-violet-700 hover:text-violet-700':
          !button && !disabled,
        'items-center rounded border-2 px-4 py-3 shadow motion-safe:transition':
          button,
        'cursor-pointer': !disabled,
        'cursor-not-allowed text-gray-400': disabled,
        'border-violet-700 bg-violet-50 text-violet-900': button && checked,
        'border-gray-400 focus-within:border-violet-500 focus-within:ring-2 focus-within:ring-violet-300 focus-within:ring-opacity-75':
          button && !disabled,
        'border-gray-300 bg-gray-50 shadow-none': button && disabled,
        'hover:border-violet-500': button && !checked && !disabled,
      },
      $attrs.class as string,
    ]"
    :style="$attrs.style as string"
    tabindex="-1"
    :for="uniqueId"
    :aria-labelledby="labelledById"
  >
    <input
      :id="uniqueId"
      v-model="model"
      v-bind="{ ...filteredAttrs, ...filteredProps }"
      type="checkbox"
      class="peer absolute shrink-0 cursor-pointer opacity-0 disabled:cursor-not-allowed"
      :class="{
        'size-[1.25em]': !labelledById,
        'size-[2.75em]': labelledById,
      }"
    />
    <svg
      width="32"
      height="32"
      viewBox="-2 -2 36 36"
      aria-hidden="true"
      focusable="false"
      class="pointer-events-none shrink-0 rounded"
      :class="{
        'size-[1.25em]': !labelledById,
        'm-[0.625em] size-[1.5em]': labelledById,
        'peer-checked:text-violet-700 peer-hover:text-violet-500 peer-checked:peer-hover:text-violet-700 peer-focus:text-violet-700 peer-checked:[&_path]:[stroke-dashoffset:0] peer-checked:[&_path]:[stroke-opacity:1]':
          !disabled,
        'peer-focus-visible:outline-none peer-focus-visible:ring-2 peer-focus-visible:ring-violet-300 peer-focus-visible:ring-opacity-75':
          !button,
      }"
    >
      <rect
        class="motion-safe:transition-all"
        width="32"
        height="32"
        x="0"
        y="0"
        rx="4"
        ry="4"
        stroke="currentColor"
        fill="none"
        :stroke-width="labelledById ? 3.333 : 4"
      />
      <path
        class="motion-safe:transition-all"
        d="M8,17 Q11,19 14,24 Q17,17 25,8"
        stroke="currentColor"
        stroke-opacity="0.5"
        stroke-width="5"
        stroke-linecap="round"
        stroke-linejoin="round"
        stroke-dasharray="32"
        stroke-dashoffset="32"
        fill="none"
      />
    </svg>
    <span
      v-if="!labelledById"
      class="motion-safe:transition-colors"
      :class="{
        'ml-2': !button,
        'ml-3': button,
      }"
    >
      <slot>{{ label }}</slot>
    </span>
  </label>
</template>

<script lang="ts" setup>
import { computed, PropType, useAttrs } from 'vue'
import { useFormElementId } from '../../composables'

defineOptions({
  name: 'UiCheckbox',
  inheritAttrs: false,
})

const props = defineProps({
  disabled: {
    type: Boolean,
    default: false,
  },
  label: {
    type: String,
    default: '',
  },
  labelledById: {
    type: String,
    default: '',
  },
  name: {
    type: String,
    default: '',
  },
  modelValue: {
    type: Array as PropType<(string | number | boolean)[]>,
    default: () => [],
  },
  value: {
    type: [String, Number, Boolean],
    required: true,
  },
  button: {
    type: Boolean,
    default: false,
  },
})

const filteredProps = computed(() => {
  const { name, label, labelledById, button, modelValue, ...filteredProps } =
    props
  return filteredProps
})

const filteredAttrs = computed(() => {
  const { class: _, style, ...filteredAttrs } = useAttrs()
  return filteredAttrs
})

const emit = defineEmits(['update:modelValue'])

const model = computed({
  get: () => props.modelValue,
  set: (value) => {
    emit('update:modelValue', value)
  },
})

const { uniqueId } = useFormElementId(props)

const checked = computed(() => {
  return props?.modelValue?.includes(props.value)
})
</script>
